;*************************************************************************
;************************** VERSION 5 OF BC CIRCUIT ********************
;THIS VERSION USES AN ANALOG MULTIPLEXER TO RUN A NEG VOLTAGE PUMP AND TO
;REPLACE THE LEVEL TRANSLATOR STAGES IN BC4.
;*************************************************************************

.EQU	CLOCK,KEYBASE		;LOADED WITH -1 AFTER INITIAL KEY CIRCUIT
				;TRY.  THEN ITS DECED EACH NMI.  IF 0,
				;KEY CIRCUIT METHOD IS SET VALID.
				;OUTSIDE ROUTINES SHOULD NOT LOOK AT THIS
				;VARIABLE.

.EQU	METHOD,KEYBASE+1	;KEY CIRCUIT METHOD USED:

.EQU	LOV35,H'02		;NOTE *** THIS METHOD NOT USED IN THIS VERSION
				;82 MEANS TRYING PULSE ON 35
				;02 MEANS PULSE ON 35 WORKED
.EQU	SMALLPULSE35,H'03
				;83 MEANS TRYING PULSE ON 35
				;03 MEANS PULSE ON 35 WORKED
.EQU	PULSE35,H'04
				;84 MEANS TRYING PULSE ON 35
				;04 MEANS PULSE ON 35 WORKED
.EQU	LOV170,H'05
				;85 MEANS TRYING LO VOLT PULSE ON 70
				;05 MEANS IT WORKED
.EQU	LOV270,H'06
				;86 MEANS TRYING LO VOLT PULSE ON 70
				;06 MEANS IT WORKED
.EQU	LOV370,H'07
				;87 MEANS TRYING LO VOLT PULSE ON 70
				;07 MEANS IT WORKED
.EQU	WEAK70,H'08
				;88 MEANS TRYING LO VOLT PULSE ON 70
				;08 MEANS IT WORKED
.EQU	SHORTPULSE70,H'09
				;89 MEANS TRYING SINGLE SHORT PULSE ON 70
				;09 MEANS THIS WORKED
.EQU	STRONGPULSE70,H'0A   
				;8A MEANS TRYING SINGLE LONG PULSE ON 70
				;0A MEANS THIS WORKED
.EQU	MULTIPULSE70,H'0B
				;8B MEANS TRYING MULTIPLE PULSES ON 70
				;0B MEANS THIS WORKED

.EQU	VERIFIER,KEYBASE+2	;KEY CIRCUIT METHOD VERIFIER.  METHOD XOR -1.

;SEE IF WE HAVE TRIED OR ESTABLISHED A METHOD TO BOOT THE NES WITH.  

	LDA	METHOD
	EOR	VERIFIER
	CMP	#-1
	BEQ	TRIED_SOME

;WE HAVE NEVER TRIED ANY METHOD.  TRY PULSE TO 35

	JMP	TRYREGPULSE


;WE HAVE TRIED A METHOD.  SEE IF IT WAS SUCCESSFUL.

TRIED_SOME:
	LDA	METHOD
	CMP	#SMALLPULSE35
	BEQ	TRYREGPULSE	;IF SUCCESSFUL SMALL PULSE ON 35, BACK TO LO V
	CMP	#PULSE35
	BEQ	TRYREGPULSE	;IF SUCCESSFUL BIG PULSE ON 35, THIS TIME TRY
	CMP	#LOV170		;A SMALLER PULSE (UNIT IS WARMER NOW)
	BEQ	TRYLOV170	;IF LO VOLTAGE PULSE ON 70 WORKS, THIS TIME TRY
	CMP	#LOV270		;A SMALLER PULSE (UNIT IS WARMER NOW)
	BEQ	TRYLOV170	;IF LO VOLTAGE PULSE ON 70 WORKS, THIS TIME TRY
	CMP	#LOV370		;A SMALLER PULSE (UNIT IS WARMER NOW)
	BEQ	TRYLOV170	;IF LO VOLTAGE PULSE ON 70 WORKS, THIS TIME TRY
	CMP	#SHORTPULSE70
	BEQ	TRYLOV170	;IF SHORT PULSE ON 70 WORKED, THIS TIME TRY LO V
	CMP	#MULTIPULSE70
	BEQ	TRYLOV170	;IF MULTIPLE PULSES ON 70 WORKED, THIS TIME TRY
				;A SINGLE SHORT PULSE (UNIT IS WARMER NOW)

	CMP	#SMALLPULSE35|H'80	;SEE IF LAST TRY WAS SMALL PULSE ON 35
	BEQ	TRY2PULSE		;IF SO, TRY BC3 PULSES ON 35
	CMP	#PULSE35|H'80	;SEE IF LAST TRY WAS PULSE ON 35
	BEQ	TRYLOV170	;IF SO, TRY LO VOLTAGE PULSE ON 70
	CMP	#LOV170|H'80	;SEE IF LAST TRY WAS LO VOLT PULSE ON 70
	BEQ	TRYLOV270	;IF SO, TRY LO VOLTAGE PULSE ON 70
	CMP	#LOV270|H'80	;SEE IF LAST TRY WAS LO VOLT PULSE ON 70
	BEQ	TRYLOV370	;IF SO, TRY LO VOLTAGE PULSE ON 70
	CMP	#LOV370|H'80	;SEE IF LAST TRY WAS LO VOLT PULSE ON 70
	BEQ	TRYSHORT70	;IF SO, TRY SHORT PULSE ON 70
	CMP	#SHORTPULSE70|H'80	;SEE IF LAST TRY WAS SHORT PULSE ON 70
	BEQ	TRYMULTI70	;IF SO, TRY MULTIPLE PULSES ON 70
	JMP	TRYREGPULSE	;IF LAST TRY WAS MULTIPLE PULSES OR INVALID CODE,
				;THEN BACK TO START WITH PIN 35 (NOTHING WORKED)

TRYREGPULSE:
 	LDA	#SMALLPULSE35|H'80
	STA	METHOD
	EOR	#-1
	STA	VERIFIER
	JMP	DOSM35

TRY2PULSE:
 	LDA	#PULSE35|H'80
	STA	METHOD
	EOR	#-1
	STA	VERIFIER
	JMP	DO35

TRYSHORT70:
	LDA	#SHORTPULSE70|H'80
	STA	METHOD
	EOR	#-1
	STA	VERIFIER		
	JMP	DOSHORT70

TRYMULTI70:
	LDA	#MULTIPULSE70|H'80
	STA	METHOD
	EOR	#-1
	STA	VERIFIER		
	JMP	DOMULTI70

TRYLOV170:
	LDA	#LOV170|H'80
	STA	METHOD
	EOR	#-1
	STA	VERIFIER		
	JMP	DOLOV170

TRYLOV270:
	LDA	#LOV270|H'80
	STA	METHOD
	EOR	#-1
	STA	VERIFIER		
	JMP	DOLOV270

TRYLOV370:
	LDA	#LOV370|H'80
	STA	METHOD
	EOR	#-1
	STA	VERIFIER		
	JMP	DOLOV370

;ROUTINES THAT ACTUALLY GENERATE THE PULSES

;THESE ROUTINES PUT PULSES ON PIN 35

DOSM35:	 
	JSR	STARTCHARGE
	JSR 	DELAY001
	JSR	ENDCHARGE
	JSR	DELAY001
TRSM36:  LDY	#H'04
	 STY	TRSM36+1
TRSM35:  LDX	#H'0C
      	 STX	TRSM35+1
 	 JMP	XEXIT

DO35:	JSR	CHGCYCLE
	JSR	XPULSE
	JSR	XPULSE
	JMP	XEXIT

;THIS ROUTINE GENERATES A .005 SECOND HIGH AND THEN LOW PULSE.

XPULSE:	LDA	#H'0C
	STA	XPULSE+1
	JSR	DELAY005
ZEROX:	LDA	#H'04
	STA	ZEROX+1
	JMP	DELAY005

;THESE ROUTINES PUT PULSES ON PIN 70

DOLOV170:
	 JSR	STARTCHARGE	;.25 MSEC CHARGE = 1.5 V
	 LDX	#20		;WAS 100
DLV705:	 DEX
	 BNE	DLV705
	 JSR	ENDCHARGE
	 JSR	DELAY025
	 JMP	XBDSH70

DOLOV270:
	 JSR	STARTCHARGE 	 ;0.5 MSEC CHARGE = -2.25 V 
	 LDX	#40		;WAS 180
	 JMP	DLV705

DOLOV370: 
	 JSR	STARTCHARGE	;1 MSEC CHARGE = -3.0 V
	 LDX	#70		;255
	 JMP	DLV705

;	 JSR	DELAY001
;	 JSR	ENDCHARGE
;	 JSR	DELAY025
;	 JMP	XBDSH70

DOSHORT70:			
	 JSR	CHGCYCLE	;SHORT 3 V PULSE
	 JSR	CHGCYCLE
XBDSH70: LDY	#H'08
	 STY	XBDSH70+1
	 JSR	DELAY001
XBDOS70: LDX	#H'0C
      	 STX	XBDOS70+1
 	 JMP	XEXIT

DOMULTI70: 
	LDA	VERIFIER
	PHA
	LDA	#15
	STA	VERIFIER
DOM69:	JSR	CHGCYCLE
	JSR	CHGCYCLE
DOM70:	LDX	#H'08
	STX	DOM70+1
	LDX	#50
DOM705:	DEX
	BNE	DOM705
DOM71:	LDX	#H'0C
	STX	DOM71+1
	DEC	VERIFIER
	BNE	DOM69
	PLA
	STA	VERIFIER
	JMP	XEXIT 

DELAY001:		;THIS ROUTINE DELAYS ABOUT .001 SEC.
	LDY	#2
	LDX	#70
	JMP	XXX10

;THIS ROUTINE DELAYS .0025 SECONDS.

DELAY005:
      	LDY	#4
	LDX	#58		;(MAKES 3*256 + 1*58)
XXX10:	DEX
	BNE	XXX10
	DEY
	BNE	XXX10
	RTS

;THIS ROUTINE DELAYS .05 SECONDS.

DELAY025:
      	LDY	#H'20
	LDX	#H'C8		;(MAKES 31*256 + 1*200)
	JMP	XXX10

;CAPACITOR CHARGING ROUTINES FOR GENERATING NEGATIVE VOLTAGE

CHGCYCLE: JSR	STARTCHARGE
	 JSR	DELAY025
	 JSR	ENDCHARGE
	 JSR	DELAY025
	 RTS

STARTCHARGE:
	LDX	#H'00
	STX	STARTCHARGE+1
	RTS

ENDCHARGE:
	LDX	#H'0C
	STX	ENDCHARGE+1
	RTS

XEXIT:	
	LDA	#127
	STA	CLOCK		;SET FULL TIME TO TRY OUT KEY CHIP METHOD


